SystemOrganization addCategory: #BICHOS!

Object subclass: #Comida
	instanceVariableNames: 'masa ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

Comida subclass: #Alfajor
	instanceVariableNames: 'chipsChocolate chips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Alfajor methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 12:38'!
chipsChocolate: anObject

	chips := anObject.
	masa := chips * 20! !

!Alfajor methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 12:41'!
initialize

	self chipsChocolate: 0! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:46'!
actualizarMasa: unaCantidad


	self masa: self masa - unaCantidad - 1! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:49'!
comidaEsExtraible

 	self masa = 0
	
		ifFalse: [ ^true.]
			
		ifTrue: [self error: 'no se puede extraer mas comida']
	! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:04'!
masa
	^ masa! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:04'!
masa: anObject
	masa:= anObject! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:04'!
ubicacion

	^ ubicacion
! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:05'!
ubicacion: unaUbicacion

	ubicacion := unaUbicacion.! !

Object subclass: #EstadoCansada
	instanceVariableNames: 'ubicacionesPorEstado alimentoPorEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:32'!
alimentoPorEstado

	^ alimentoPorEstado min: 0.! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 22:55'!
alimentoPorEstado: unaCantidad

	alimentoPorEstado := unaCantidad.
! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:32'!
descansa: hormigaAfectada
	hormigaAfectada normalizada.! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:31'!
ubicacionesPorEstado

	^ ubicacionesPorEstado.! !

Object subclass: #EstadoExaltada
	instanceVariableNames: 'ubicacionesPorEstado alimentoPorEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:31'!
alimentoPorEstado

	^ (alimentoPorEstado min: 10)*2.! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:30'!
alimentoPorEstado: unaCantidad
	alimentoPorEstado := unaCantidad.
! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:30'!
descansa: hormigaAfectada! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:30'!
ubicacionesPorEstado

	^ ubicacionesPorEstado.! !

Object subclass: #EstadoNormal
	instanceVariableNames: 'ubicacionesPorEstado alimentoPorEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 12:19'!
comidaPorEstado

	 ^10! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 23:28'!
descansa: hormigaAfectada
	hormigaAfectada exaltada.! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 15:17'!
extraerDe: unaComida con: unaHormiga
	
	
	((unaComida comidaEsExtraible) and: (unaHormiga puedeLlevar)) 
	
	ifTrue:[	
			unaComida actualizarMasa: (unaHormiga comidaQuePuedeLlevar). 
			unaHormiga comidaQueLleva: 10.
			]. ! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 02:20'!
llevarAlimentoA: unHormiguero con: unaHormiga

	unaHormiga moveteA: (unHormiguero ubicacion).
	
	unaHormiga almacenarComidaEn: unHormiguero! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 16:00'!
moveteA: unaUbicacion1 una: hormigaAfectada
	|ubicacionAnterior|
	hormigaAfectada ubicacionesPorLasQuePaso add: unaUbicacion1.
	hormigaAfectada sumarViajes.
	hormigaAfectada sumarDistanciaRecorridaA: unaUbicacion1.
	hormigaAfectada ubicacion: unaUbicacion1.
	ubicacionAnterior := hormigaAfectada ubicacion.
	((ubicacionAnterior distanciaA: unaUbicacion1) > 10) ifTrue: [hormigaAfectada cansada].
		
	! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 15:16'!
puedeLlevarConEstado: unaHormiga

	^(unaHormiga comidaQueLleva <= 10).! !

Object subclass: #Hormiga
	instanceVariableNames: 'hormiguero comidaQueLleva ubicacion estado ubicacionesPorLasQuePaso distanciasTotales cantidadDeUbicacionesPorLasQuePaso distanciaRecorrida cantidadDeRecorridos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:56'!
alLimite
	
	^ self comidaQueLleva >= 9.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:31'!
almacenarComidaEn: unHormiguero

	unHormiguero agregarComida: (self comidaQueLleva).
	
	self entregarAlimento.
! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:08'!
cansada
	
	self estado: EstadoCansada new.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:07'!
cantidadDeRecorridos

	^ cantidadDeRecorridos! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:08'!
cantidadDeRecorridos: anObject

	cantidadDeRecorridos:= anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:52'!
comidaQueFaltaParaLlegarAlLimite

	^ 10 - self comidaQueLleva.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:01'!
comidaQueLleva

	^ comidaQueLleva.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:54'!
comidaQueLleva: anObject

	comidaQueLleva:= anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 14:38'!
comidaQuePuedeLlevar
	^((self estado) comidaPorEstado - self comidaQueLleva) ! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:09'!
descansa

	estado descansa: self.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/28/2015 23:01'!
distancia: unaUbicacion
	
	^ self ubicacion dist: unaUbicacion ubicacion.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:44'!
distanciaPromedio

	^ (self distanciaRecorrida) / (self cantidadDeRecorridos).! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 00:06'!
distanciaPromedioUltimasUbicaciones: unaCantidad

	^ (self distanciaRecorridaUltimasUbicaciones: unaCantidad)/ unaCantidad.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/28/2015 22:48'!
distanciaRecorrida
	
	^distanciaRecorrida.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 22:48'!
distanciaRecorrida: anObject

	distanciaRecorrida := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:48'!
distanciaRecorridaUltimasUbicaciones: unaCantidad
	
	^ (self ubicacionesPorLasQuePaso last: unaCantidad) sum.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:46'!
distanciasTotales
	^distanciasTotales.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:32'!
entregarAlimento

	self comidaQueLleva: 0.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 20:31'!
estado
	^ estado! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 20:31'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:59'!
exaltada
	
	self estado: EstadoExaltada new.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:44'!
extraerAlimentoDe: unaComida

	self moveteA: (unaComida ubicacion).
	
	estado extraerDe: unaComida con: self.


	

	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:18'!
initialize

	comidaQueLleva:= 0.
	distanciaRecorrida := 0.
	cantidadDeRecorridos := 0.
	estado := EstadoNormal new.
	ubicacionesPorLasQuePaso := Set new.
	ubicacion := Ubicacion new.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:57'!
limiteDisponible

	^ 10 - comidaQueLleva.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 02:11'!
llevarAlimentoA: unHormiguero

	estado llevarAlimentoA: unHormiguero con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:20'!
moveteA: unaUbicacion

	(self estado) moveteA:unaUbicacion una: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:10'!
normalizada
	self estado: EstadoNormal new.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 15:15'!
puedeLlevar

	^(self estado) puedeLlevarConEstado: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:10'!
sumarDistanciaRecorridaA: unaUbicacion1

	self distanciaRecorrida: ((self distanciaRecorrida) + ((self ubicacion) distanciaA: unaUbicacion1))! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:20'!
sumarRecorridos

	self cantidadDeRecorridos: self cantidadDeRecorridos  + 1.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:10'!
sumarViajes

	self cantidadDeRecorridos: self cantidadDeRecorridos  + 1.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:10'!
ubicacion
	
	^ ubicacion.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:10'!
ubicacion: unEspacio

	ubicacion:= unEspacio.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:25'!
ubicacionesPorLasQuePaso

	^ ubicacionesPorLasQuePaso.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:07'!
ubicacionesPorLasQuePaso: anObject

	ubicacionesPorLasQuePaso:= anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/28/2015 23:17'!
ultimasUbicacionesPorLasQuePaso: unaCantidad

	^self ubicacionesPorLasQuePaso last: unaCantidad.! !

Object subclass: #Hormiguero
	instanceVariableNames: 'depositoDeComida hormigasTotales ubicacion hormigas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:36'!
agregarComida: unaCantidad

	self depositoDeComida: self depositoDeComida + unaCantidad.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:01'!
agregarHormiga: unaHormiga

	self hormigasTotales add: unaHormiga.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:14'!
cantidadHormigasTotales

	^hormigasTotales size.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:23'!
comidaEnTotal

	^depositoDeComida + self comidaRecolectada.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:35'!
comidaRecolectada

	^ hormigasTotales sum: [: hormiga | hormiga comidaQueLleva]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:11'!
depositoDeComida

	^depositoDeComida.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:22'!
depositoDeComida: anObject

	depositoDeComida := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 18:29'!
hormigasTotales
	
	^ hormigasTotales.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:03'!
hormigasTotales: anObject 

	hormigasTotales:= anObject 	! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:15'!
initialize

	hormigasTotales:= Bag new.
	depositoDeComida:=0.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:06'!
juntarAlimento


	self hormigasTotales do:[: unaHormiga | unaHormiga llevarComidaA: self].
	! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:08'!
ubicacion
	
	^ ubicacion.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:08'!
ubicacion: unaUbicacion

	ubicacion := unaUbicacion.! !

Object subclass: #Ubicacion
	instanceVariableNames: 'coordenada1 coordenada2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:24'!
coordenada1

	^coordenada1 ! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:25'!
coordenada1: anObject

	coordenada1 := anObject! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:24'!
coordenada2

	^coordenada2! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:25'!
coordenada2: anObject

	coordenada2 := anObject! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:40'!
distanciaA: unaUbicacion

	^(((coordenada1-(unaUbicacion coordenada1))raisedTo:2)+ (((coordenada2 - (unaUbicacion coordenada2)) raisedTo:2 )))sqrt.
! !
